import socket
from commands import IGNORE
from commands import DIRECT 
from commands import BROADCAST 

import sys
import binascii
import traceback
import logging

class Peer(object):
    def __init__(self, socket, peer_entry):
        self.handles = peer_entry["handles"]
        self.keys = peer_entry["keys"]
        self.peer_id = peer_entry["peer_id"]
        self.address = peer_entry["address"]
        self.port = peer_entry["port"]
        self.socket = socket 
        self.forked = peer_entry.get("forked")

    def get_key(self):
        if len(self.keys) > 0:
            return self.keys[0]
        else:
            return None

    def send(self, signed_packet_bytes):
        if self.get_key() != None and self.address != None and self.port != None:
            try:
                self.socket.sendto(signed_packet_bytes, (self.address, self.port))   

            except Exception as ex:
               stack = traceback.format_exc()
               logging.debug(stack)
        else:
            logging.debug("Discarding message to unknown handle or handle with no key: %s" % self.handles[0])
